CLASS zcl_invoice DEFINITION
  PUBLIC
  FINAL
  CREATE PUBLIC .

  PUBLIC SECTION.
    INTERFACES if_rap_query_provider.
  PROTECTED SECTION.
  PRIVATE SECTION.
ENDCLASS.



CLASS ZCL_INVOICE IMPLEMENTATION.


  METHOD if_rap_query_provider~select.
    TRY.
        TRY.
            "IF io_request->is_data_requested(  ).
            "io_request->get_paging( ).
            DATA: rt_customer TYPE RANGE OF zdxm,
                  rt_wbs      TYPE RANGE OF char24.
            DATA(lo_paging) = io_request->get_paging( ).
            DATA(lv_skip) = io_request->get_paging( )->get_offset(  ).
            DATA(lv_top) = io_request->get_paging( )->get_page_size(  ).
            DATA(lt_sort_elements) = io_request->get_sort_elements( ) .
            DATA(lt_ranges) = io_request->get_filter( )->get_as_ranges( )."Basic search term
            DATA(lt_filter_cond) = io_request->get_parameters( ). "setting the filter condition, fetching parameter names from data definition

            LOOP AT lt_ranges REFERENCE INTO DATA(lr_range).
              CASE lr_range->name.
                WHEN 'SoldToParty'.
                  LOOP AT lr_range->range REFERENCE INTO DATA(lr_range_entry).
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE rt_customer.
                  ENDLOOP.
                WHEN 'WBSElementExternalID'.
                  LOOP AT lr_range->range REFERENCE INTO lr_range_entry.
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE rt_wbs.
                  ENDLOOP.
              ENDCASE.
            ENDLOOP.

            DATA:lt_table     TYPE STANDARD TABLE OF zcv_xmkp,
                 lt_table_out TYPE STANDARD TABLE OF zcv_xmkp,
                 ls_table     TYPE zcv_xmkp.
            TRY.
                "基本数据
                SELECT SoldToParty,
                       WBSElementExternalID,
                       SUM( Subtotal1Amount ) AS Subtotal1Amount
                   FROM I_SalesOrderItemCube( P_DisplayCurrency = 'CNY', P_ExchangeRateType = 'M' )
                   WHERE SalesOrderType EQ 'TA'
                   AND SoldToParty IN @rt_customer
                   GROUP BY SoldToParty, WBSElementExternalID
                   INTO CORRESPONDING FIELDS OF TABLE @lt_table.
                IF lt_table IS NOT INITIAL.
                  "发票相关数量
                  SELECT Customer,
                         TransactionCurrency,
                      SUM( AmountInTransactionCurrency ) AS AmountInTransactionCurrency,
                      SUM( PaidAmount ) AS PaidAmount,
                      SUM( OpenAmountInDocumentCurrency ) AS OpenAmountInDocumentCurrency
                      FROM yy1_nickt01"C_CollectionsInvoiceMemory "I_CollectionsInvoiceMemory
                      WHERE customer IN @rt_customer
                      GROUP BY Customer,TransactionCurrency
                      INTO TABLE @DATA(lt_invoice).
                  SORT lt_invoice BY customer.
*                  "项目信息
*                  SELECT Project AS WBSElementExternalID,
*                       yy1_zzps001
*                       FROM I_EnterpriseProject
*                       FOR ALL ENTRIES IN @lt_table
*                       WHERE project = @lt_table-I_EnterpriseProject
*                       INTO TABLE @DATA(lt_ep).
                  "客户名称
                  SELECT customer,
                        customername
                      FROM I_Customer
                      WHERE customer IN @rt_customer
                      INTO TABLE @DATA(lt_customer).
                  SORT lt_customer BY customer.
*                  SELECT CostEstimate
*                      FROM YY1_ZCO001
*                      INTO TABLE @DATA(lt_invoice1).
                  "客户名称
                ENDIF.
                LOOP AT lt_table INTO ls_table.
                  READ TABLE lt_invoice INTO DATA(ls_invoice) WITH KEY customer = ls_table-SoldToParty BINARY SEARCH.
                  IF sy-subrc EQ 0.
                    MOVE-CORRESPONDING ls_invoice TO ls_table.
                    CLEAR ls_invoice.
                  ENDIF.
                  "客户名称
                  READ TABLE lt_customer INTO DATA(ls_customer) WITH KEY customer = ls_table-SoldToParty BINARY SEARCH.
                  IF sy-subrc EQ 0.
                    ls_table-CustomerName = ls_customer-CustomerName.
                    CLEAR ls_customer.
                  ENDIF.
                  MODIFY lt_table FROM ls_table.
                  CLEAR ls_table.
                ENDLOOP.
              CATCH cx_sy_dynamic_osql_syntax INTO DATA(lx_data). " exception to catch and manage dynamic query errors . must use this in order to work properly
            ENDTRY.
            "lo_response->get_business_data( IMPORTING et_business_data = lt_table ).
*            DATA lv_lines TYPE int8.
*            lv_lines = lines( lt_table ).
            DATA(lv_start) = lv_skip + 1.
            IF lv_top <= 0.
              lv_top = 50.
            ENDIF.
            DATA(lv_end) = lv_skip + lv_top.

            APPEND LINES OF lt_table FROM lv_start TO lv_end TO lt_table_out.

            io_response->set_total_number_of_records( lines( lt_table ) ).
            io_response->set_data( lt_table_out ).
            "io_response->set_total_number_of_records( lines( lt_table  ) ).
            "ENDIF.
          CATCH  cx_rap_query_provider INTO DATA(lx_exc).
        ENDTRY.
      CATCH cx_rfc_dest_provider_error INTO DATA(lx_dest).
    ENDTRY.
  ENDMETHOD.
ENDCLASS.
